# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.network_slice_quality import NetworkSliceQuality  # noqa: F401,E501
from swagger_server import util


class NewNetworkSlice(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, name: str=None, quality: NetworkSliceQuality=None, subnet_ip: str=None, gateway_ip: str=None):  # noqa: E501
        """NewNetworkSlice - a model defined in Swagger

        :param name: The name of this NewNetworkSlice.  # noqa: E501
        :type name: str
        :param quality: The quality of this NewNetworkSlice.  # noqa: E501
        :type quality: NetworkSliceQuality
        :param subnet_ip: The subnet_ip of this NewNetworkSlice.  # noqa: E501
        :type subnet_ip: str
        :param gateway_ip: The gateway_ip of this NewNetworkSlice.  # noqa: E501
        :type gateway_ip: str
        """
        self.swagger_types = {
            'name': str,
            'quality': NetworkSliceQuality,
            'subnet_ip': str,
            'gateway_ip': str
        }

        self.attribute_map = {
            'name': 'name',
            'quality': 'quality',
            'subnet_ip': 'subnet_ip',
            'gateway_ip': 'gateway_ip'
        }
        self._name = name
        self._quality = quality
        self._subnet_ip = subnet_ip
        self._gateway_ip = gateway_ip

    @classmethod
    def from_dict(cls, dikt) -> 'NewNetworkSlice':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The NewNetworkSlice of this NewNetworkSlice.  # noqa: E501
        :rtype: NewNetworkSlice
        """
        return util.deserialize_model(dikt, cls)

    @property
    def name(self) -> str:
        """Gets the name of this NewNetworkSlice.


        :return: The name of this NewNetworkSlice.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this NewNetworkSlice.


        :param name: The name of this NewNetworkSlice.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def quality(self) -> NetworkSliceQuality:
        """Gets the quality of this NewNetworkSlice.


        :return: The quality of this NewNetworkSlice.
        :rtype: NetworkSliceQuality
        """
        return self._quality

    @quality.setter
    def quality(self, quality: NetworkSliceQuality):
        """Sets the quality of this NewNetworkSlice.


        :param quality: The quality of this NewNetworkSlice.
        :type quality: NetworkSliceQuality
        """
        if quality is None:
            raise ValueError("Invalid value for `quality`, must not be `None`")  # noqa: E501

        self._quality = quality

    @property
    def subnet_ip(self) -> str:
        """Gets the subnet_ip of this NewNetworkSlice.


        :return: The subnet_ip of this NewNetworkSlice.
        :rtype: str
        """
        return self._subnet_ip

    @subnet_ip.setter
    def subnet_ip(self, subnet_ip: str):
        """Sets the subnet_ip of this NewNetworkSlice.


        :param subnet_ip: The subnet_ip of this NewNetworkSlice.
        :type subnet_ip: str
        """
        if subnet_ip is None:
            raise ValueError("Invalid value for `subnet_ip`, must not be `None`")  # noqa: E501

        self._subnet_ip = subnet_ip

    @property
    def gateway_ip(self) -> str:
        """Gets the gateway_ip of this NewNetworkSlice.


        :return: The gateway_ip of this NewNetworkSlice.
        :rtype: str
        """
        return self._gateway_ip

    @gateway_ip.setter
    def gateway_ip(self, gateway_ip: str):
        """Sets the gateway_ip of this NewNetworkSlice.


        :param gateway_ip: The gateway_ip of this NewNetworkSlice.
        :type gateway_ip: str
        """
        if gateway_ip is None:
            raise ValueError("Invalid value for `gateway_ip`, must not be `None`")  # noqa: E501

        self._gateway_ip = gateway_ip
